
def read_mifare_card(serial_number):
    from nfc import NfcReaderWriter
    from nfc.tag import Tag
    from nfc.tag.mifare import MifareTag

    reader = NfcReaderWriter()
    tag = reader.connect(serial_number)
    if not isinstance(tag, MifareTag):
        raise ValueError("Connected tag is not a Mifare tag")

    # Read the first block of the Mifare card
    data = tag.read_block(0)
    return data



